;
; ZX81VARS.INC
; include file with variables used by Sinclair ZX81
; for FASMZ80 (flatassembler with Z80 instruction set)
;
; V1.0
; (C)opyright by Karl-Heinz Dahlmann, Mnchen
;

        include 'ZX81DEF.INC'           ; definitions of constants


	ORG		MEMST		; begin of system variables fro ZX81
ERR_NR: 				; error flag (error-1, FF => 0)
	ORG		MEMST+1
FLAGS:					; system flags, see ZX81DEF.INC for explanation
	ORG		MEMST+2
ERR_SP: 				; begin of GOSUB stack
	ORG		MEMST+4
RAMTOP: 				; top of RAM, first non existing memory location
	ORG		MEMST+6
MODE:					; cursor mode (K/L)
	ORG		MEMST+7
PPC:					; line number executing

	ORG		MEMST+9
SAVE_BEGIN:
	VERSN		db 0		; version, 0=ZX81 BASIC
	E_PPC		dw 1		; number of current line with cursor (in listing)
	D_FILE		dw DFILE_ADDR	; begin of D_FILE (display file) in memory
	DF_CC		dw DFILE_ADDR+1 ; current cursor position in D_FILE (used for print routine)

	VARS		dw VARS_ADDR	; begin of variable section in memory
	DEST		dw 0		; address of variable in assignment

	E_LINE		dw WORKSPACE	; address of workspace
;        CH_ADD          dw WORKSPACE+4  ; address of next character to be interpreted
	CH_ADD		dw AUTOLD	; address of next character to be interpreted
	X_PTR		dw 0		; address of character preceeding "S" marker

;        STKBOT          dw WORKSPACE+5  ; stack botton (top-down)
	STKBOT		dw WORKSPACE	; stack botton (top-down)
;        STKEND          dw WORKSPACE+5  ; end of stack (top)
	STKEND		dw WORKSPACE	; end of stack (top)
	BERG		db 0		; calculators b register, possibly write error, should be BREG :-)

	MEMBOT	EQU	16477
	PRBUFF	EQU	16444

	MEM		dw MEMBOT	; address for calculator's memory
	UNUSED_1	db 0		; unused variable / space
	DF_SZ		db 2		; no. of lines in lower part of screen including 1 blank line
	S_TOP		dw 0		; no. of top program line in automatic listings
	LAST_K		dw 0BFFDh	; last key pressed
	DEBOUNCE	db 0FFh 	; debounce status of keyboard
	MARGIN		db MARGVAL	; margin value, could be used PAL or NTSC
;        NXTLIN          dw DFILE_ADDR   ; next line to be executed
	NXTLIN		dw AUTOLD+1   ; next line to be executed

;        OLDPPC          dw 0            ; line to jump when executing CONT (continue)
	OLDPPC		dw 2		; line to jump when executing CONT (continue)
	FLAGX		db 0		; internal flags
	STRLEN		dw 0		; length of string, internally used

	T_ADDR		dw 0C8Dh	; next item in syntax (token) table

	SEED		dw 0		; seed variable set by RAND

	FRAMES		dw $8FFF	; counter of frames sent to TV, used by PAUSE command
	COORDS		db 0		; x coordinate of last point plotted
			db 0		; y coordinate of last point plotted

	PR_CC		db 0BCh 	; LPRINT position used with real printer
	S_POSN		db 33		; column no. for print position
			db 24		; line no. for print position
	CDFLAG		db DISPMOD	; compute and display flag

	include 	'ZX81FAL2.INC'

;        PRBUFF          db 32 dup(0)    ; printer buffer, initialized with 0
;                        db NEWLINE      ; printer buffer ends with a newline character
;        MEMBOT          db 30 dup(0)    ; calculator additional memory            ???
;        UNUSED_2        dw 0            ; unused variable / space
			 db 16509-$ dup(0)

PROG_AREA:

